unit Unit1;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, Vcl.Controls, Vcl.StdCtrls, WEBLib.StdCtrls,
  Data.DB, XData.Web.JsonDataset, XData.Web.Dataset, XData.Web.Connection;

type
  TForm1 = class(TWebForm)
    btnConnect: TWebButton;
    btnShowData: TWebButton;
    WebMemo1: TWebMemo;
    XDataWebConnection1: TXDataWebConnection;
    XDataWebDataSet1: TXDataWebDataSet;
    btnAppendNewData: TWebButton;
    btnApplyUpdates: TWebButton;
    btnPrior: TWebButton;
    btnNext: TWebButton;
    btn_UploadMemoText: TWebButton;
    procedure btnConnectClick(Sender: TObject);
    procedure btnShowDataClick(Sender: TObject);
    procedure XDataWebConnection1Connect(Sender: TObject);
    procedure btnAppendNewDataClick(Sender: TObject);
    procedure btnApplyUpdatesClick(Sender: TObject);
    procedure XDataWebDataSet1AfterApplyUpdates(Sender: TDataSet;
      Info: TResolveResults);
    procedure btnPriorClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btn_UploadMemoTextClick(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure Log(aMessage: String);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Log(aMessage: String);
begin
  WebMemo1.Lines.Add(TimeToStr(Now)+ ': '+ aMessage);
end;

procedure TForm1.btnAppendNewDataClick(Sender: TObject);
begin
  XDataWebDataSet1.Append;
//  XDataWebDataSet1.Fields[0].AsInteger := -1;  // ID is generated on xData-Server
  XDataWebDataSet1.Fields[1].AsString := 'New '+TimeToStr(Now);
  XDataWebDataSet1.Post;
end;

procedure TForm1.btnPriorClick(Sender: TObject);
begin
  XDataWebDataSet1.Prior;
end;

procedure TForm1.btnApplyUpdatesClick(Sender: TObject);
begin
  XDataWebDataSet1.ApplyUpdates;
end;

procedure TForm1.btnConnectClick(Sender: TObject);
begin
  XDataWebConnection1.Connected := True;
end;

procedure TForm1.btnNextClick(Sender: TObject);
begin
  XDataWebDataSet1.Next;
end;

procedure TForm1.btnShowDataClick(Sender: TObject);
begin
  Log(XDataWebDataSet1.Fields[0].AsString+' - '+XDataWebDataSet1.Fields[1].AsString);
end;

procedure TForm1.btn_UploadMemoTextClick(Sender: TObject);
var
  LID: Integer;
  xhr: TJSXmlHttpRequest;

  function strEncodeUTF16(str: string): TJSArrayBuffer;
  var
    BufView: TJSUInt16Array;
    I: Integer;
  begin
    Result := TJSArrayBuffer.new(Length(str) * 2);
    BufView := TJSUInt16Array.new(Result);
    for I := 0 to Length(str) - 1 do
      BufView[I] := TJSString(str).charCodeAt(I);
  end;

begin
  LID := XDataWebDataSet1.FieldByName('ID').AsInteger;

  xhr := TJSXMLHttpRequest.new;
  xhr.open('PUT',
    xDataWebConnection1.URL + '/' +
    XDataWebDataSet1.EntitySetName+'('+LID.ToString+')/DESCRIPTION'
  );
  xhr.overrideMimeType('text/plain; charset=ansi');
  xhr.send( strEncodeUTF16(WebMemo1.Lines.Text) );
end;

procedure TForm1.XDataWebConnection1Connect(Sender: TObject);
begin
  XDataWebDataSet1.Load;
  Log('Connected');
end;

procedure TForm1.XDataWebDataSet1AfterApplyUpdates(Sender: TDataSet;
  Info: TResolveResults);
var
  I: integer;
  BM: TBookmark;
  LID: Integer;
begin
  console.log(Info);
  BM := XDataWebDataset1.GetBookmark;
  try
    for I := 0 to Length(Info.Records)-1 do
    begin
      XDataWebDataset1.GotoBookmark(Info.Records[I].BookMark);
      TJSObject(XDataWebDataset1.CurrentData)['ID'] := TJSObject(Info.Records[I].Data)['ID'];
//      LID := integer (TJSObject(Info.Records[I].Data)['ID']);
//      TJSObject(XDataWebDataset1.CurrentData)['DESCRIPTION@xdata.ref'] := 'SIMPLETABLE(' + LID.ToString + ')/DESCRIPTION';
    end;
  finally
    XDataWebDataset1.GotoBookmark(BM);
  end;end;

end.
